# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline().strip())
if 1 > n or n > 1000000:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

l = 0
for i in range(n):
	s = map(int, fi.readline().strip().split())
	if 1 > s[0] or s[0] > 3:
		sys.exit('T[{0}] out of range'.format(1 + i))
	if s[0] == 1:
		if len(s) != 3:
			sys.exit('Invalid format on line {0}'.format(1 + i))
		if 1 > s[1] or s[1] > 9:
			sys.exit('F[{0}] out of range'.format(1 + i))
		if 1 > s[2] or s[2] > 9:
			sys.exit('S[{0}] out of range'.format(1 + i))
		l += 1
	if s[0] == 2:
		if len(s) != 2:
			sys.exit('Invalid format on line {0}'.format(1 + i))
		if 1 > s[1] or s[1] > l:
			sys.exit('K[{0}] out of range'.format(1 + i))
		l -= s[1]
	if s[0] == 3:
		if len(s) != 2:
			sys.exit('Invalid format on line {0}'.format(1 + i))
		if 1 > s[1] or s[1] > l + 1:
			sys.exit('P[{0}] out of range'.format(1 + i))
	fo.write('{0}\n'.format(' '.join(map(str, s))))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 1000:
		print('subtask 1')
	else:
		print('subtask 2')
