#include "seif.h"
#include <algorithm>

static const int maxn = 1000000;
static int c[1 + maxn], x[1 + maxn];
static int cn = 1, xn = 1;

void Add(int f, int s) {
	c[cn] = f + s;
	if (c[cn] != 9) {
		x[xn] = cn;
		++xn;
	}
	++cn;
}

void Del(int k) {
	cn -= k;
	xn = std::lower_bound(x, x + xn, cn) - x;
}

int Get(int p) {
	int ci = cn - p;
	int xi = std::upper_bound(x, x + xn, ci) - x;
	if (xi == xn) {
		return c[ci] % 10;
	} else {
		return (c[ci] + c[x[xi]] / 10) % 10;
	}
}
