# -*- coding: utf8 -*-

# 2018-03-18 programmeerimisvõistlus
# Ülesanne: RINGTEED
# Autor: Ahto Truu
# Testitud: Python 2.7 / CygWin; Python 3.6 / CygWin

# Naiivne lahendus kõigi variantide läbiproovimisega

# Globaalsed muutujad graafi esitamiseks
# g[i] - tipu i naabrite loend
# v[i] - tipu i olek graafi läbimisel
# l[i] - kas tipp i on olnud marsuudi lõpp

def otsi(i):
	v[i] = 1
	k = 0 # mitmesse naabrisse saab edasi minna
	for j in g[i]:
		if v[j] == 0:
			k += 1
			otsi(j)
	if k == 0: # kui ei saanud kuhugi edasi
		l[i] = 1 # siis on siin marsruudi lõpp
	v[i] = 0

with open('ringsis.txt', 'r') as sis:
	n, m, s = [int(i) for i in sis.readline().strip().split()]
	g = [[] for i in range(n + 1)]
	v = [0 for i in range(n + 1)]
	l = [0 for i in range(n + 1)]
	for i in range(m):
		a, b = [int(i) for i in sis.readline().strip().split()]
		g[a].append(b)
		g[b].append(a)

otsi(s)

with open('ringval.txt', 'w') as val:
	val.write('{0}\n'.format(sum(l)))
