#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
	FILE *sis = fopen("valiksis.txt", "r");
	FILE *val = fopen("valikval.txt", "w");

	int n, T;
	fscanf(sis, "%d %d", &n, &T);
	vector<int> a(n), t(n);
	for (int i = 0; i < n; i++) {
		fscanf(sis, "%d %d", &a[i], &t[i]);
	}
	vector<int> res;
	int low = 0, high = n;
	while (low < high) {
		int mid = (low + high + 1) >> 1;
		vector< pair<int, int> > e;
		for (int i = 0; i < n; i++) {
			if (a[i] >= mid) {
				e.emplace_back(t[i], i);
			}
		}
		sort(e.begin(), e.end());
		bool ok = false;
		if ((int)e.size() >= mid) {
			int sum = 0;
			for (int i = 0; i < mid; i++) {
				sum += e[i].first;
			}
			if (sum <= T) {
				ok = true;
				res.resize(mid);
				for (int i = 0; i < mid; i++) {
					res[i] = e[i].second;
				}
			}
		}
		if (ok) {
			low = mid;
		}
		else {
			high = mid - 1;
		}
	}

	int sz = (int)res.size();
	sort(res.begin(), res.end());

	fprintf(val, "%d\n", sz);
	for (int i = 0; i < sz; i++) {
		if (i > 0) {
			fprintf(val, " ");
		}
		fprintf(val, "%d", res[i] + 1);
	}
	fprintf(val, "\n");
	return 0;
}